/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in 
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2007.  All Rights Reserved.
 *
 * Protege was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu.
 *
 */

package edu.stanford.smi.protege.widget;

import java.awt.GridLayout;

import javax.swing.JCheckBox;

import edu.stanford.smi.protege.util.AbstractValidatableComponent;
import edu.stanford.smi.protege.util.LabeledComponent;

public class ReadOnlyWidgetConfigurationPanel extends AbstractValidatableComponent{

	private AbstractSlotWidget widget;
	private JCheckBox readOnlyCheckBox;

	public ReadOnlyWidgetConfigurationPanel(AbstractSlotWidget widget) {
		this.widget = widget;
		
		setLayout(new GridLayout(0,1,10,10));
		
		readOnlyCheckBox = new JCheckBox("Read-only (Users will not be able to edit the value of this widget)");
		readOnlyCheckBox.setSelected(widget.isReadOnlyConfiguredWidget());
		
		LabeledComponent labledComp = new LabeledComponent("Options", readOnlyCheckBox, true);
		add(labledComp);
	}
		
	
	public void saveContents() {
		widget.setReadOnlyWidget(readOnlyCheckBox.isSelected());	
	}

	public boolean validateContents() {	
		return true;
	}

}
